subroutine CCSDT(nO,nV,t1,t2,EcCCT)

! Compute the (T) correction of the CCSD(T) energy

  implicit none

! Input variables

  integer,intent(in)            :: nO,nV

  double precision,intent(in)   :: t1(nO,nV)
  double precision,intent(in)   :: t2(nO,nO,nV,nV)

! Local variables

  double precision,allocatable  :: ub(:,:,:,:,:,:)
  double precision,allocatable  :: ubb(:,:,:,:,:,:)

! Output variables

  double precision,intent(out)  :: EcCCT

! Memory allocation

  allocate(ub(nO,nO,nO,nV,nV,nV),ubb(nO,nO,nO,nV,nV,nV))

! Form CCSD(T) quantities

  call form_ub(nO,nV,t1,ub)

  call form_ubb(nO,nV,t2,ubb)

  call form_T(nO,nV,ub,ubb,EcCCT)

end subroutine CCSDT
